/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * "Portions Copyright (c) 2003 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/FSCL.txt
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Josh Wilsdon <josh@wizard.ca>
 *
 * CVS Id: $Id: read_rules.c,v 1.3 2003/09/19 18:56:03 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "spam_rules.h"

/* global + user spam rule structures */
extern spam_rule_t user_rules[];
extern spam_rule_t global_rules[];

unsigned char isEnabled(int id, int rule)
{
    if (id == 0) {
        /* global */

        if ((global_rules[rule].type == RULE_BOOL)
            && (global_rules[rule].entries > 0)
            && (global_rules[rule].first != NULL)
            && (global_rules[rule].first->data != NULL)
            && (strncmp(global_rules[rule].first->data, "true", 4) == 0)) {
            /* enabled */
            return ((unsigned char) 1);
        }
    } else {
        /* user */

        if ((user_rules[rule].type == RULE_BOOL)
            && (user_rules[rule].entries > 0)
            && (user_rules[rule].first != NULL)
            && (user_rules[rule].first->data != NULL)
            && (strncmp(user_rules[rule].first->data, "true", 4) == 0)) {

            /* enabled */
            return ((unsigned char) 1);
        }
    }

    /* not enabled */
    return ((unsigned char) 0);
}
