#!/usr/bin/perl -w
#
# COPYRIGHT INFORMATION - DO NOT REMOVE
# Copyright (c) 2003 LinuxMagic Inc. All Rights Reserved.
#
# This file contains Original Code and/or Modifications of Original Code as
# defined in and that are subject to the Free Source Code License Version
# 1.0 (the 'License'). You may not use this file except in compliance with
# the License. Please obtain a copy of the License at:
#
# http://www.linuxmagic.com/opensource/licensing/
#
# and read it before using this file.
#
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
# the License for the specific language governing rights and limitations
# under the License."
#
# Please read the terms of this license carefully. By using or downloading
# this software or file, you are accepting and agreeing to the terms of this
# license with LinuxMagic Inc. If you are agreeing to this license on behalf
# of a company, you represent that you are authorized to bind the company to
# such a license. If you do not meet this criterion or you do not agree to
# any of the terms of this license, do NOT download, distribute, use or alter
# this software or file in any way.
#
# Author:  Josh Wilsdon (josh@wizard.ca)
# Version: $Id: magicmail-spamlogger.pl,v 1.2.2.1 2003/05/20 19:19:56 josh Exp $
#
# DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
# 

use DBI;

$dbname="user_acl";             # Database name for Postgres
$dbhost="204.244.205.8";        # hostname/IP of database server
$dbport="5432";			        # port
$dbuser="user_acl_owner";       # user for Postgres
$dbpass="user_acl_owner";       # password for Postgres

%smtp = ();

$dbh = DBI->connect( "DBI:Pg:dbname=$dbname;host=$dbhost;port=$dbport", $dbuser, $dbpass, { RaiseError => 0, PrintError => 0 });
defined $dbh or die "Could not connect to database";

LINE: while($line = <STDIN>) {
	chomp($line);

	if ($line !~ m/msd\[(\d+)\]\:/) {
		next LINE;
	}
    $pid = $1;

   if ($line =~ m/msd\[\d+\]:\sLinux\sMagic\sSMTPD\sstarted:\sconnection\sfrom\s([^\s]+)/) {

        $host = $1;

        # remove old records with this pid
        delete $smtp{$pid};

        # save host
        $smtp{$pid}{"ip"} = $host; 

        # done with this line
        next LINE;
    } elsif ($line =~ m/^([^\s]+\s\d+\s[0-9:]+).*msd\[\d+\]:\sSPAM_HIT\s(.*)$/) {

	# print "$line\n";

	$date = $1;
        $data = $2;
	$smtp{$pid}{"date"} = $date;
        $smtp{$pid}{"data"} = $data;
	if ($data =~ m/R:([^\s]+)\sF:([^\s]+)\s(.*)$/) {
	    $smtp{$pid}{"rcpt"} = $1;
	    $smtp{$pid}{"mail"} = $2;
	    $smtp{$pid}{"rule"} = $3;
	}
    } elsif ($line =~ m/msd\[\d+\]:\sexiting/) {

        # reason will be set if there was a spam hit, so if it is not set, it
        # spam was not detected
        if (defined $smtp{$pid}{"data"}) {
            #defined $smtp{$pid}{"data"} && print "  \\_ LOG:" . $smtp{$pid}{"data"} . "\n";
            #defined $smtp{$pid}{"date"} && print "  \\_ DATE:" . $smtp{$pid}{"date"} . "\n";
            #defined $smtp{$pid}{"rcpt"} && print "  \\_ RCPT TO:" . $smtp{$pid}{"rcpt"} . "\n";
            #defined $smtp{$pid}{"mail"} && print "  \\_ MAIL FROM:" . $smtp{$pid}{"mail"} . "\n";
            #defined $smtp{$pid}{"rule"} && print "  \\_ RULE:" . $smtp{$pid}{"rule"} . "\n";
	    
	    $email_to = $smtp{$pid}{"rcpt"};
	    ($email_name, $email_domain) = split('@', $email_to, 2);
	    $email_ip = $smtp{$pid}{"ip"};
	    $email_from = $smtp{$pid}{"mail"};
	    $spam_rule = $smtp{$pid}{"rule"};
	    $date = $smtp{$pid}{"date"} . " " . ((localtime())[5] + 1900);
	    $date = "to_timestamp('$date', 'Mon DD HH24:MI:SS YYYY')";

    	    $query =  "INSERT INTO spam_log (email_name, email_domain, ip, from_addr, subject, reason, datetime)";
	    $query .= "VALUES ('$email_name', '$email_domain', '$email_ip', '$email_from', '', '$spam_rule', $date)";

	    # NOTE: currently ignoring errors
	    $sth = $dbh->prepare($query);
	    $sth->execute();
	    $sth->finish;

            #print "\n";
        }
        delete $smtp{$pid};

    }
}

$dbh->disconnect;

exit(0);
