/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * "Portions Copyright (c) 2002-2003 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Burton Samograd <burton@wizard.ca>
 *
 * CVS Id: $Id: spam_check.h,v 1.5 2003/12/22 17:58:38 bart Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#include <liblm.h>

#include "config_spam_rule.h"

#ifndef _SPAM_CHECK_H
#define _SPAM_CHECK_H

int spam_check_do(config_spam_rule_t *spam_rules, lm_string_t rcptaddr, lm_string_t fromaddr, int *whitelist);
int check_in_list(  lm_string_t str, 
                    int DEPENDS, 
                    char *list_name, 
                    int (*cmp) (lm_string_t, lm_string_t),
                    config_spam_rule_t *rules,
                    int global_whitelist_flag,
                    int global_blacklist_flag,
                    strlist_t global_whitelist,
                    strlist_t personal_whitelist,
                    strlist_t global_blacklist,
                    strlist_t personal_blacklist,
                    char *buffer, 
                    char *hit_str,
                    lm_string_t rcptaddr,
                    lm_string_t fromaddr,
                    int *whitelist); 

#endif
